\chapter{Classes}

Objects in Utena are \emph{instances} of \emph{classes}, and classes
combine a \emph{class definition} and a \emph{enclosing object}.
Each class definition has a sequence of slot definitions and a sequence
of methods.

\section{Slots}

A slot associates a value with a name and an object.
A slot may store an arbitrary value, which may or may not be replaced
after the object is constructed. If the value may not be replaced, the
slot is called an \emph{immutable slot}; if the value may be replaced, the
slot is called a \emph{mutable slot}. Either kind of slot has an
\emph{initialisation method}, which is called in the context of the
constructor in order to produce an initial value for the slot.
A program reads the value in a slot by using a \emph{reader} method,
and a program replaces the value in a slot by using a \emph{writer}
method. The names and visibility of both methods are stored in the
slot definition, and a programmer may choose the names and
visibility arbitrarily.

If the value in a slot does not need to be replaced, a programmer should
favour using immutable slots to make this obvious to readers of their
code, and to allow an implementation to more aggressively cache slot
values, improving performance.

%% We went with making these be methods, not slots.
%% A slot may always store a reference to the instance the slot resides in;
%% this kind of slot is called a \emph{self slot}. As the name suggests, the
%% slot is typically used to provide a way to access for the \texttt{self} value,
%% but a self slot may have any name.
%% A self slot is explicitly provided by the programmer as some objects,
%% such as closures, are selfless. For example, the value of \texttt{self} in a
%% closure is some enclosing object and not the closure itself.

\section{Mutability}

A programmer may choose to make a class definition with only
slot definitions \emph{immutable}, eliminating the concept of object
identity and the \texttt{eq?} message (name pending). This further informs
the reader that they do not need to track identity of objects, and that
instances of an immutable class with the same slot values may be treated
interchangeably. Similarly, an implementation may choose to pass
slots rather than objects across method calls \cite[p.~70--72]{compiling-with-continuations},
deduplicate instances \cite{hash-consing}, inline instances into each other
\cites{value-class-optimisation}{unrolling-lists}, and otherwise play loosely
with identity in order to provide more efficient memory management
\cites[p.~9]{lazy-alloc}{doligez-leroy-gc}{immutable-concurrent-copying}. In a
distributed setting, an instance of an immutable class may be copied and
not proxied to reduce the frequency of remote method invocations, but such
copying may break encapsulation. A programmer thus should also prefer
using immutable classes when possible.

Classes with mutable slots are always \emph{mutable}, and their instances
always have object identity; object identity is necessary to tell how the
new value of a slot can be observed when the value of a slot is replaced.

Class objects themselves are immutable in order to allow efficient
representations of objects where instances do not have to refer to their
classes, but the implementation can reproduce the class of an instance
on demand. (The Movement Three implementation does exactly this, because
it is much more common for compiled code to traverse a chain of
enclosing objects than for compiled code to need to materialise a class
object.)

\subsection{The \texttt{eq?} message}

The method \texttt{eq?} on the VM primitives module is used to check for
object identity, i.e. that its two arguments are the ``same'' object. The behaviour
of \texttt{eq?} is non-deterministic when used to compare immutable objects
with \emph{similar} structure; an implementation may either return true
or false at its discretion. Two immutable objects are \emph{similar} if
they are of the same class, and all their slot values are similar.
\todo{There are also base cases for primitive types, e.g. two integers
  are similar if they are numerically equal. But we haven't
  chosen our primitive types yet.}

\section{Synthetic classes}

The Utena abstract machine constructs its own class definitions for
activation records, which appear when activating code methods;
such class definitions are called \emph{synthetic class definitions},
and classes made from synthetic class definitions are called
\emph{synthetic classes}. The use of synthetic classes makes the
abstract machine more uniform in how it accesses the arguments
passed to methods.%
\footnote{
Gilad Bracha argues the uniformity of synthetic classes
has low value (in \url{https://twitter.com/Gilad_Bracha/status/1591755258832850944});
I (Hayley) would agree from the viewpoint of the language user. But for
the VM and language implementors, this uniformity simplifies
the implementation of activation records. It appears Newspeak
and the Primordial Soup virtual machine do some trickery around
the representation and method lookup of activation records and
blocks instead, where the slots of the objects don't correspond with
the class.}
Note that the pervasive use of synthetic classes is supported by that
classes are immutable and thus can be rematerialised; otherwise
each instance would have to be reference synthetic classes for
every method of the class definition of the instance, which would
drastically increase the size of all objects.

\section{Mixins}

\section{Construction}
